/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DEVENT_C_H
#define _DEVENT_C_H


#include <dnpap.h>
#include <boolset.h>
#include <dlog.h>


#define EVENT_BOOLEAN_COMMUNITY		1
#define EVENT_BOOLEAN_OWNER			2


#define RMONEVENT_SZEDESCR  128
#define RMONEVENT_SZECOMM   128


typedef struct DnpapRmonEvent_
{     
	CHAR Description[RMONEVENT_SZEDESCR];
    WORD DescrLen;
	LONG Type;
	BYTE Community[RMONEVENT_SZECOMM];
    WORD CommLen;
	ULONG LastTimeSent;
	BYTE Owner[SNMP_SIZE_BUFCHR];
	WORD OwnerLen;
	WORD Status;
	
    LONG NrLogs;
	LONG LogPos;
	LONG LogIndex;
	BOOLEAN LogBounced;
	DnpapRmonLog *Logs;
	
    BooleanSet ObjectSet;

} DnpapRmonEvent;


BOOLEAN     DnpapEventCInit(DnpapRmonEvent* event);
BOOLEAN     DnpapEventCStart(DnpapRmonEvent* event);
BOOLEAN     DnpapEventCStop(DnpapRmonEvent* event);

DnpapRmonEvent*  NewDnpapRmonEvent(WORD nrevents);
DnpapRmonEvent*  ReNewDnpapRmonEvent(DnpapRmonEvent* ptr, WORD nrevents);
VOID             DelDnpapRmonEvent(DnpapRmonEvent* ptr);


#endif
