/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DFILTERC_H
#define _DFILTERC_H

#include <dnpap.h>
#include <boolset.h>
#include <snmp.h>


#define FILTER_BOOLEAN_CHANNEL		1
#define FILTER_BOOLEAN_OWNER		2


typedef struct _DNPAP_FILTER
{
    LONG    Channel;
    LONG    PktDataOffset;
    BYTE*   PktData;
    BYTE*   PktDataMask;
    BYTE*   PktDataNotMask;
    BOOLEAN PktDataNotMaskAllZero;
    WORD    PktDataLen;
    WORD    PktDataMaskLen;
    WORD    PktDataNotMaskLen;
    LONG    PktStatus;
    LONG    PktStatusMask;
    LONG    PktStatusNotMask;
    BYTE    Owner[SNMP_SIZE_BUFCHR];
    WORD    OwnerLen;
    LONG    Status;

    BooleanSet ObjectSet;

} DNPAP_FILTER;


BOOLEAN DnpapFilterCInit(DNPAP_FILTER *filter);
BOOLEAN DnpapFilterCStart(DNPAP_FILTER *filter);
BOOLEAN DnpapFilterCStop(DNPAP_FILTER *filter);


#endif

