/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWSNMP_H_
#define _NWSNMP_H_


#include <dnpap.h>
#include <snmp.h>

#include "nw.h"
#include "nwsnmpdef.h"


#define INADDR_NONE     0xffffffff


enum NwSnmpErrors
{
	NWSNMP_OK = NWSNMP_ERROR,
	NWSNMP_INIT, NWSNMP_PROTO,
	NWSNMP_NEWSNMP, NWSNMP_UDP,
	NWSNMP_ADDLIST, NWSNMP_PARAM,
	NWSNMP_ADDR
};


typedef struct _NwSnmp
{
    CHAR   Host[NWSNMP_SIZE_HOST];
	ULONG  Address;
	INT    Request;
    BYTE   Community[NWSNMP_SIZE_COMMUNITY];
	INT	   CommLen;
	NW_DG *Udp;
    
} NwSnmp;
    

typedef struct _NwSnmpDg
{          
    NW_DG  NwInfo;
    NwSnmp SnmpInfo;
    
    struct _NwSnmpDg *Prev;
    struct _NwSnmpDg *Next;
    
} NwSnmpDg;


extern NW_DG_IFACE SnmpDgIface;


BOOLEAN NwSnmpInit(VOID);
BOOLEAN NwSnmpExit(VOID);

NW_DG  *NwSnmpAccept(char *addr, NW_DG_RECV_CALL recv, VOID *param);
NW_DG  *NwSnmpConnect(char *addr, NW_DG_RECV_CALL recv, VOID *param);
BOOLEAN NwSnmpSend(NW_DG *dg, BYTE *frame, INT len);
BOOLEAN NwSnmpSendTo(NW_DG *dg, CHAR *addr, BYTE *frame, INT len);
BOOLEAN NwSnmpClose(NW_DG *dg);
BOOLEAN NwSnmpIfConfig(NW_DG *dg, NW_IFCONFIG *ifconfig);


#endif
