/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
/************************************************************************
** MODULE INFORMATION*
**********************
**     FILE     NAME:       nwtcp.h
**     SYSTEM   NAME:       nw
**     ORIGINAL AUTHOR(S):  Jan van Oorschot
**     VERSION  NUMBER:     1.00
**     CREATION DATE:       24 march 1993
**
** DESCRIPTION: Defines, prototypes and structures 
**		for the TCP interface.
**              
*************************************************************************
** CHANGE INFORMATION **
*************************
** REVISION:    $Revision$
** WORKFILE:    $Workfile$
** LOGINFO:     $Log$
*************************************************************************/
#ifndef _NWTCP_H
#define _NWTCP_H

#ifndef BSD_SELECT
#define BSD_SELECT
#endif

#ifdef OS2
#include <types.h>
#include <netlib.h>
#include <sys/select.h>       /* contains FD_*** macros */
#else
#include <sys/types.h>		
#define sock_init()	0
#define soclose(x)	close(x)
#endif
#include <netdb.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <stropts.h>
#include <errno.h>

int socket(int domain,int type,int protocol);
int bind(int s,struct sockaddr *name, int namelen);
int listen(int s,int backlog);
int close(int fd);
struct hostent *gethostbyname(char *name);
struct hostent *gethostbyaddr(char *addr, int len, int type);
int connect(int s,struct sockaddr *name, int namelen);
int send(int s, char *msg,int len,int flags);
int accept(int s, struct sockaddr *name, int *namelen);
int ioctl(int fd,int request,caddr_t arg);
int read(int fd,char *buf,int nbyte);
int gethostname(char *tbuf,int len);

typedef	struct _tcpinfo	TCPINFO;
typedef struct _tcpconn	TCPCONN;
typedef struct _tcpparam TCPPARAM;


struct _tcpinfo
{
    int		conPort;
    struct sockaddr_in addr;
    int		sckt;
    int		(*CBRec)(NWCONN *,BYTE *, int);
    BLOCK	*blk;
};
struct _tcpconn
{
    NWINFO	nwinfo;
    TCPINFO	tcpinfo;
    TCPCONN	*prior;
    TCPCONN	*next;
};
struct _tcpparam
{
    int	server;
    int ServerPort;
};

/* prototypes iface nwtcp */
int TCPInit(
	    int (*CBOpen)(NWCONN *,char *),
	    int (*CBCLose)(NWCONN *),
	    int (*CBDgramRec)(NWCONN *,BYTE *,int),
	    void *param);
int TCPExit(void);
NWCONN *TCPOpen(char *ConnInfo,int (*CBReceive)(NWCONN *,BYTE *,int));
int TCPClose(NWCONN *conn);
int TCPSend(NWCONN *conn,BYTE *frame,int len);
void TCPSetRecCB(
	NWCONN *conn,
      	int (*CBReceive)(NWCONN *con,BYTE *frame,int len));
char *TCPGetEntry(void);
int TCPConfig(char *cfg);

#endif
