/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
/************************************************************************
** MODULE INFORMATION*
**********************
**     FILE     NAME:       nw.h
**     SYSTEM   NAME:       nw
**     ORIGINAL AUTHOR(S):  Jan van Oorschot 
**     VERSION  NUMBER:     1.00
**     CREATION DATE:       24 march 1993
**
** DESCRIPTION: Global header file for the NW network 
**		library. Shouold be included by any module
**              that uses NW functions.
*************************************************************************
** CHANGE INFORMATION **
*************************
** REVISION:    $Revision$
** WORKFILE:    $Workfile$
** LOGINFO:     $Log$
*************************************************************************/


#ifndef _NW_H
#define _NW_H


#include <dnpap.h>


typedef	struct	_nwconn	NWCONN;
typedef	struct	_nwinfo	NWINFO;

struct	_nwinfo
{
    int type;
    char *ConnInfo;
    int (*CBAppReceive)(NWCONN *conn,BYTE *frame, int len);
};

struct 	_nwconn
{
    NWINFO	nwinfo;
};

/* iface type definitions */
#define	NWTCP	0
#define	NWUDP	1
#define	NWNIT	2


typedef int (*CBOpenFunc)(NWCONN *conn, CHAR *arg);
typedef int (*CBCloseFunc)(NWCONN *conn);
typedef int (*CBReceiveFunc)(NWCONN *conn, BYTE *frame, int len);
typedef int (*CBDgramRecFunc)(NWCONN *conn, BYTE *frame, int len);


/* prototypes */
int NWInit( int (*CBAppConnOpen)(NWCONN *con,char *istr),
	    int (*CBAppConnClose)(NWCONN *con),
	    int (*CBAppDgramRec)(NWCONN *con,BYTE *frame,int len));
int	NWExit(void);
NWCONN	*NWOpen(
		char *ConnInfo,
		int (*CBAppReceive)(NWCONN *con,BYTE *frame,int len));
int	NWClose(NWCONN *conn);
int	NWSend(NWCONN *conn,BYTE *frame, int len);
void 	NWSetReceiveCB(
	    NWCONN *conn, 
	    int (*CBAppReceive)(NWCONN *conn, BYTE *frame,int len));
int	NWEntries(char *buf,int len);
int NWDgramSend(char *to, BYTE *frame, int len);
int NWDgramRepl(NWCONN *con, BYTE *frame, int len);
int NWConfig(char *ConfInfo);


#endif
