#!/usr/local/bin/perl

#
#	This programm interogates an Node Discovery Collector.
#	It should be called as:
#
#	perl nodes.pl <collector> [<host> <community> <medium>]
#
require "spook.pl";	   
require "rmon/collector.pl";
#
# handle the arguments
#
if( @ARGV<1 || @ARGV>4 )
{
	die 	"call as:  perl discnode.pl <collectord> [<host> <community> <medium>]\n" ,
		" where:\n" ,
		"	<collector>		collector nr in RMON monitor\n",
		"	<host>		name of RMON monitor\n" ,
		"	<community>	community name for creating collectors\n",
		"	<medium>	UDP or PIPE\n";
}
($iniColl, $iniHost , $iniComm , $iniMed,@rest) = @ARGV;

# create the SPOOK connection
&snmp_open(1) || die "cant open a Spook connection\n";
if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";
if($iniComm ne "") {&snmp_community(1,$iniComm);}


print STDERR "interogating discNode collector $iniColl\n";

#
# define the functions
#
#
# receive a row of the table, for the use with snmp_tbl
#
sub handleRow
{
	local($i,$j,@repl) = @_;
	if($j == 1)
	{
	    print $localFile "\n$localId $localTable ";
	}
	print $localFile "$repl[2] ";
}

#
# request the discEtherNode table
#
# input variables:
#      
#      1: $conn        spook connection number
#      2: $host        string with name of host running Beholder
#      3: $comm        community to use 
#      4: $coll        collector number of discEtherNode collector
#      5: $id          identification string
#      6: $file        file handle to write to
#
sub discEtherNodeGardner
{
    local( $conn, $host, $comm, $coll, $id, $file) = @_;
    if($host ne "") { &snmp_host($conn,$host);}
    if($comm ne "") {&snmp_community($conn,$comm);}
    &snmp_connect($conn) || return 0;

    $localId = $id;
    $localFile = $file;

    $localTable = "EthernetNode";
#    &snmp_tbl($conn,main'handleRow,
#         (
#            "discEthernetNodeAddress[$coll]",
#            "discEthernetNodeCreationOrder[$coll]",
#            "discEthernetNodeIndex[$coll]",
#            "discEthernetNodeInPkts[$coll]",
#            "discEthernetNodeInOctets[$coll]",
#            "discEthernetNodeOutPkts[$coll]",
#            "discEthernetNodeOutOctets[$coll]",
#            "discEthernetNodeLRUTime[$coll]"
#         ));

    $localTable = "IPNode";
    &snmp_tbl($conn,main'handleRow,
         (
	    "discIPNodeEthernetAddress[$coll]",
            "discIPNodeAddress[$coll]",
            "discIPNodeCreationOrder[$coll]",
            "discIPNodeIndex[$coll]",
            "discIPNodeInPkts[$coll]",
            "discIPNodeInOctets[$coll]",
            "discIPNodeOutPkts[$coll]",
            "discIPNodeOutOctets[$coll]",
            "discIPNodeLRUTime[$coll]"
         ));

    return 1;
}

&discEtherNodeGardner(1,$iniHost,$iniComm,$iniColl,"test",STDOUT );

&snmp_disconnect(1);
&snmp_close(1);






