#!/usr/local/bin/perl
#
#	This programm lists all collectors in a 
#	RMON monitor.
#
#	showcolls.pl [<host> <community> <medium>]
#
#
require "spook.pl";	   
require "rmon/collector.pl";
#
# handle the arguments
#
if( @ARGV<0 || @ARGV>3 )
{
	die 	"call as:  perl colls.pl [<host> <community> <medium>]\n" ,
		" where:\n" ,
		"	<host>		name of RMON monitor\n" ,
		"	<community>	community name for creating collectors\n",
		"	<medium>	UDP or PIPE\n";
}
($iniHost , $iniComm , $iniMed,@rest) = @ARGV;

# create the SPOOK connection
&snmp_open(1) || die "cant open a Spook connection\n";
if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";
if($iniComm ne "") {&snmp_community(1,$iniComm);}

#
# list of all possible collector types
#
@collList = (
	"etherStats",
	"historyControl",
	"alarm",
	"hostControl",
	"hostTopN",
	"matrixControl",
	"filter",
	"channel",
	"bufferControl",
	"event",
	"beholderInfo",
	"neuro",
	"discNodeControl",
	"discConnControl"
);
#
# check for all Collector types if there are collectors running
#
print "Type\t\tNr\tOwner String\t\tStatus\n"; 
print "--------------- ------- ----------------------- -------\n"; 
foreach $collType (@collList)
{
	@collNrList = &list_collectors(1,$collType);
	foreach $collNr (@collNrList)
	{
		# Owner  	--> ownerstring
		# Status	--> current status of collector
		$name = $collType . "Owner[" . $collNr . "]";
		$owner = &snmp_get(1,$name);
		$name = $collType . "Status[" . $collNr . "]";
		$status = &snmp_get(1,$name);
		print "$collType\t$collNr\t$owner\t$status\n"; 
	}
}

&snmp_disconnect(1);
&snmp_close(1);
exit;
