#!/usr/local/bin/perl # -*-Perl-*-

# uses the discovery collector to report the IP conversations 
# going on on the network
require "spook.pl";	   
require "rmon/collector.pl";
require "rmon/discconn.pl";
require "rmon/rmonutil.pl";

#
# handle the arguments
#
if( @ARGV<1 || @ARGV>3 )
{
	die 	"call as:  perl discconntst.pl <period> [<host> <community> <medium>]\n" ,
		" where:\n" ,
	        "       <period>        sleeping period in seconds\n",
		"	<host>		name of RMON monitor\n" ,
		"	<community>	community name for creating collectors\n",
		"	<medium>	UDP or PIPE\n";
}
($iniPeriod, $iniHost , $iniComm , $iniMed,@rest) = @ARGV;

# create the SPOOK connection
&snmp_open(1) || die "cant open a Spook connection\n";

if($iniHost ne "") { &snmp_host(1,$iniHost);}
if($iniMed ne "")  {&snmp_medium(1,$iniMed);}
if($iniComm ne "") {&snmp_community(1,$iniComm);}
&snmp_connect(1) || die "could't connect to ($iniHost,$iniMed)";


while(1)
{
$iniColl = &discConnCreator( 1, "testOwner" , 1) || die "could not create collector" ;
print STDERR "interogating discNode collector $iniColl\n";

open(GFILE,">/tmp/discconn.dat.$$") || die "could not open gardner output file";
sleep($iniPeriod);
&discConnGardner(1,$iniColl,"test",main'GFILE );
close(GFILE);

#
# process the gardner output, forming several ass. arrays
#
open(GFILE,"</tmp/discconn.dat.$$") || die "could not open gardner outpur";

%EtherConnOctets=();
%EtherConnFrames=();
%IPConnOctets=();
%IPConnFrames=();
%UDPConnOctets=();
%UDPConnFrames=();
%TCPConnOctets=();
%TCPConnFrames=();


while($line = <GFILE>)
{
   @res = split(' ',$line);
   if( $res[1] eq "discConnControlStart")
   {
       
   } 
   elsif( $res[1] eq "discEthernetConnSD")
   {
       $EtherConnOctets{"$res[2] $res[3]"} = $res[6];
       $EtherConnFrames{"$res[2] $res[3]"} = $res[5];
   }
   elsif( $res[1] eq "discIPConnSD")
   {
       $IPConnOctets{"$res[3] $res[5]"} = $res[8];
       $IPConnFrames{"$res[3] $res[5]"} = $res[7];
       $IP2Ether{"$res[3]"} = $res[2];
       $IP2Ether{"$res[5]"} = $res[4];
   }
   elsif( $res[1] eq "discUDPConnSD")
   {
       if($res[4]<10240 || $res[7]<10240)
       {
	   $UDPConnOctets{"$res[3] $res[4] $res[6] $res[7]"} = $res[10]; 
	   $UDPConnFrames{"$res[3] $res[4] $res[6] $res[7]"} = $res[9]; 
       }
   }
   elsif( $res[1] eq "discTCPConnSD")
   {
       if($res[4]<10240 || $res[7]<10240)
       {
	   $TCPConnOctets{"$res[3] $res[4] $res[6] $res[7]"} = $res[10]; 
	   $TCPConnFrames{"$res[3] $res[4] $res[6] $res[7]"} = $res[9]; 
       }
   }
   elsif ($res[1] eq "discConnControlEnd")
   {
   }
}

#
# give a printed report
#
sub keycompTCP
{ 
    $TCPConnOctets{$a} < $TCPConnOctets{$b};
}

printf("%c[H%c[2J",27,27);
$cnt =0;
foreach $key (sort keycompTCP keys(%TCPConnOctets))
{
#    print "$key -> $TCPConnOctets{$key}\n";
    ($from,$fromp,$to,$top) = split(' ',$key);
    printf("%30s[%s] \t--TCP-> %30s[%s] \t==> %d/%d\n",
	   &ip2name($from),
	   &serv2name($fromp,'tcp'),
	   &ip2name($to),
	   &serv2name($top,'tcp'),
	   $TCPConnOctets{$key},
	   $TCPConnFrames{$key});
    $cnt++;
    if($cnt>= 10)
    {
	last;
    }
}
#
# give a printed report
#

sub keycompUDP 
{ 
    $UDPConnOctets{$a} < $UDPConnOctets{$b};
}

print "\n";
$cnt = 0;
foreach $key (sort keycompUDP keys(%UDPConnOctets))
{
#    print "$key -> $UDPConnOctets{$key}\n";
    ($from,$fromp,$to,$top) = split(' ',$key);
    printf("%30s[%s] \t--UDP-> %30s[%s] \t==> %d/%d\n",
	   &ip2name($from),
	   &serv2name($fromp,'udp'),
	   &ip2name($to),
	   &serv2name($top,'udp'),
	   $UDPConnOctets{$key},
	   $UDPConnFrames{$key});
    $cnt++;
    if($cnt>= 10)
    {
	last;
    }
}


&discConnTerminator(1,$iniColl,"testOwner");
}

&snmp_disconnect(1);
&snmp_close(1);



























